module Stockman
  module Logic
    class Kit
      class StockLevel
        attr_reader :kit_contents, :warehouse_id

        def initialize(kit_contents, warehouse_id)
          @kit_contents = kit_contents
          @warehouse_id = warehouse_id.to_i
        end

        def physical_amount
          kit_contents.minimum_physical_amount(warehouse_id)
        end

        def allocated_amount
          0
        end

        def available_amount
          kit_contents.minimum_available_amount(warehouse_id)
        end
      end
    end
  end
end
