require_relative "product/sellables_collection"
require_relative "product/stock_level"
require_relative "product/stock_levels_collection"

module Stockman
  module Logic
    class Product
      attr_reader :id

      def initialize(id)
        @id = id
      end

      def total_physical_amount
        stock_levels.sum(&:physical_amount)
      end

      def total_allocated_amount
        stock_levels.sum(&:allocated_amount)
      end

      def total_available_amount
        stock_levels.sum(&:available_amount)
      end

      def stock_levels
        @stock_levels ||= StockLevelsCollection.new(id)
      end

      def summary
        @summary ||= Summary.from_object(self)
      end
    end
  end
end
