module Stockman
  module Logic
    class Product
      class StockLevel
        attr_reader :sellables, :warehouse_id

        def initialize(sellables, warehouse_id)
          @sellables    = sellables
          @warehouse_id = warehouse_id.to_i
        end

        def physical_amount
          sellables_stock_levels.sum(&:physical_amount)
        end

        def allocated_amount
          sellables_stock_levels.sum(&:allocated_amount)
        end

        def available_amount
          sellables_stock_levels.sum(&:available_amount)
        end

        def sellables_stock_levels
          @sellables_stock_levels ||= sellables.stock_levels.select do |stock_level|
            stock_level.warehouse_id == warehouse_id
          end
        end
      end
    end
  end
end
