module Stockman
  module Logic
    class SellableFactory
      VALID_SELLABLE_TYPES = ['variants', 'kits']

      def self.build_sellable(sellable_data)
        type, id = *sellable_data.split(":")

        raise "#{type} is not valid sellable type" unless VALID_SELLABLE_TYPES.include?(type)

        "Stockman::Logic::#{type.singularize.classify}".constantize.new(id.to_i)
      end
    end
  end
end
