module Stockman
  module Logic
    class Variant
      class StockLevel
        attr_reader :variant_id, :warehouse_id

        def initialize(variant_id, warehouse_id)
          @variant_id = variant_id.to_i
          @warehouse_id = warehouse_id.to_i
        end

        def physical_amount
          obtain_amount(:physical)
        end

        def allocated_amount
          obtain_amount(:allocated)
        end

        def available_amount
          physical_amount - allocated_amount
        end

        private

        def obtain_amount(type)
          Storage.obtain_amount("variants:#{variant_id}:stock_levels:#{warehouse_id}", :"#{type}_amount")
        end
      end
    end
  end
end
